//+------------------------------------------------------------------+
//|                                                        Nero2.mq4 |
//|                                                     Vetrov F. A. |
//|                                           http://www.nothere.net |
//+------------------------------------------------------------------+
#property copyright "Vetrov F. A."
#property link      "http://www.nothere.net"

//--------------------------      -----------------------

extern int in          = 8;           //         (  99)
extern int hid         = 3;           //     
extern int out         = 1;           //     

bool       IsInit      = 0;           //   
bool       IsLearn     = 0;           //  
double     NetOut;
int        Epoha;

double D[][100];
double W[][100];
double Corr[][100];
double Squar[][100];

//--------------   -----------------------------
double OUT(int bar = 0)
{
   int i;
   double res = 0.0;
   
   if(!IsInit)
      NetInit();
      
   for( i= 1; i <= hid; i++ )
      Hidden(i,bar);
      
   for( i = 0; i <= hid; i++)
      res += D[hid+1,i] * W[hid+1,i];
         
   return(th(res));    
}

//---------------    ------------------------
void Hidden(int num, int bar = 0)
{
   int i;
   
   if(!IsInit)
      return;
   if(num < 1 || num > hid) 
      return;  
      
   GetIn(num,bar);   
     
   for(i = 0; i <= in; i++)
      D[hid+1,num] += D[num,i] * W[num,i];
      
   D[hid+1,num] = th(D[hid+1,num]);   
   return;
}
//---------------------------------------------------------------
//                 
//---------------------------------------------------------------

//------------------  -------------------------------
double th(double x)
{ 
    double res; 
    
    if(MathAbs(x)<100.0)
       res=(MathExp(x)-MathExp(-x))/(MathExp(x)+MathExp(-x));
    else 
       res=MathAbs(x)/x;
    return(res);
} 

//------------------    --------------
void GetIn( int num, int bar, double kf = 400.0 ) 
{
   int i,j;
   
   switch(num)
   {
    case 1: for(i = 1; i <= in; i++)
               {
                  j = bar + i - 1;
                  D[num][i] = th(kf*(Open[j] - Open[j+1])/Open[j+1]);       //   1 /,    .../
               } 
            break;    
    case 2: for(i = 1; i <= in; i++)
               {
                  j = bar + i - 1;
                  D[num][i] = th(kf*(Open[j] - Open[j+1])/Open[j+1]);       //   2 /,    .../
               } 
            break;
    case 3: for(i = 1; i <= in; i++)
               {
                  j = bar + i - 1;
                  D[num][i] = th(kf*(Open[j] - Open[j+1])/Open[j+1]);       //   3 /,    .../
               } 
            break;            
   default: Print("   GetIn:     !"); //   
            break;                
   }
   return;
}

//----------------------------   ----------------------
void NetInit()
{
   int i,j;
   
   if(IsInit)
      return;
      
   ArrayResize(D,hid+2);                                                //   D
   ArrayInitialize(D,0.0); 
   
   ArrayResize(W,hid+2);                                                //   W
   ArrayInitialize(W,0.0); 
   
   ArrayResize(Corr,hid+2);                                             //   Corr
   ArrayInitialize(Corr,0.0); 
    
   ArrayResize(Squar,hid+2);                                            //   Squar
   ArrayInitialize(Squar,0.0); 
   
   MathSrand(TimeLocal());
   
   for(i = 1; i <= hid+1; i++)                                          //   
     D[i,0] = 1.0;
     
   for(i = 1; i <= hid+1; i++)                                          //       +/-1
     for(j = 0; j <= in; j++)
     {
      if( (i == hid+1) && (j > hid) )
         break;   
      W[i,j] = (2.0*MathRand() - 32767.0)/32767.0;
     }
   Epoha = (4 * (in+1+hid+1)*(in+1+hid+1))/(in+1);                      //    
   IsInit = 1;                                                          //     
}    

void Guru(int train = 99)
{
   int i,j,k,n;
   double res = 0.0, test = 0.0, Din, Dout;
   double er_in[100] = {,0.0};                                             //  
   
   if(IsLearn)
      train = 1;
      
   for(k = 0; k <= train; k++ )                                           //  
      {
        for(n = Epoha; n >= 1; n--)                                       // 
          {
            res = OUT(n);                                                 //   
            test = (Open[n-1] - Open[n])/Open[n];                         // n+1   
            er_in[0] = (test - res) * (1 - res*res);                      //     
            
            for(i = 0; i <= hid; i++)                                     //       
               {                                                          //  
                Corr[hid+1,i]  += er_in[0] * D[hid+1,i];
                Squar[hid+1,i] += Corr[hid+1,i]*Corr[hid+1,i];            //  
               }
               
            for(i = 1; i <= hid; i++)                                     //    i-   
               er_in[i] = er_in[0] * (1 - D[hid+1,i]*D[hid+1,i]);
               
            for(i = 1; i <= hid; i++)                                     //     
               for(j = 0; j <= in; j++)                                   // i-   
               {
                Corr[i,j]  += er_in[i] * D[i,j];
                Squar[i,j] += Corr[i,j] * Corr[i,j];
               } 
           } 
        for(i = 0; i <= hid; i++)                                         //    
           W[hid+1,i] += Corr[hid+1,i]/Squar[hid+1,i];
        
        for(i = 1; i <= hid; i++)                                         //   i-    
           for(j = 0; j <= in; j++)
              W[i,j] += Corr[i,j]/Squar[i,j];       
      }   
}